﻿/*
# SMART IMAGE SETTING EXTENSION TOOL
# 저작자 : IDO - FRONT END - Dev Wabi
# 최초 작성일 : 2018 - 01 - 23
* 본 문서의 소스와 정보에 대한 모든 권리는 (주)스마트스킨에게 있습니다.
* 사전 동의없이는 동일,유사의 수준에서 어떠한 형식과 방법으로든 무단 도용을 금합니다.
* 만일 위와 같은 권고에도 불구하고 무단 도용시 저작권법에 의거하여 법적인 제재를 받으실 수 있습니다.

* Author info
	* Dev Wabi
	* Front End Developer
* browser info
	* Chrome
* sorce info
	* jQuery

=============================================================== */
chrome.extension.getBackgroundPage().console.log('OptJS START. Ver 2.1.4');
const smiToolFn = {
    vars : {
        //bkg : chrome.extension.getBackgroundPage(),
        defObj : {
            "type" : 'off',
            "host" : '',
            "hostID" : ''
        },
        detailObj : {
            code : ''
        },
        res : '',
        nowUrl : '',
        smiT : null
    },
    fns : {
        alertFn : function(txt){
            //init first
            $('#alertWrap').removeClass('active');
            $('#alertWrap .alt-body').html('');
            //set
            $('#alertWrap').addClass('active');
            $('#alertWrap .alt-body').html(txt);
        },
        loaderFn : function(opt){
            if(opt === true){
                $('#loader').addClass('loading');
            }else{
                $('#loader').removeClass('loading');
            }
        },
        setConnecting : function(type, key, value){
            //type , key , value  :: setConnecting
            /*
            type
            reload : sessionSet all and tab reload
            --
            set : sessionSet all
            remove : sessionRemove all
            */
            //let bkg = smiToolFn.vars.bkg;
            let res = smiToolFn.vars.res;
            let detailObj = smiToolFn.vars.detailObj;

            //init
            detailObj.code = '';

            switch (type){
                case 'reload' :
                    detailObj.code = "localStorage.setItem('"+key+"', '"+value+"');location.reload();";
                    //localStorage.setItem(key,value);
                    break;
                case 'set' :
                    detailObj.code = "localStorage.setItem('"+key+"', '"+value+"');";
                    //localStorage.setItem(key,value);
                    break;
                case 'remove' :
                    detailObj.code = "localStorage.removeItem('"+key+"');location.reload();";
                    //localStorage.removeItem(key);
                    break;
            }
            chrome.tabs.executeScript(null, detailObj);
            if(type === "reload") window.close();
        },
		
		checkFn : function(callBack){
			let chkVal = {
				activate : 0,
				host : 0,
				hostID : ''
			}
			
			chkVal.activate = $('input[name="activeRange"]:checked').length;
			chkVal.host = $('input[name="shopHost"]:checked').length;
			chkVal.hostID = $('#shopHostID').val().trim();
			
			let res = [false,'',[]];
			let errTxt = {
				act : '<div class="f-danger">( ! ) 활성화를 설정하세요.</div>',
				host : '<div class="f-danger">( ! ) 호스팅사를 설정하세요.</div>',
				hostDuplicate : '<div class="f-danger">( ! ) 호스팅사는 한 곳만 설정해주세요.</div>',
				hostID : '<div class="f-danger">( ! ) 호스팅 샵도메인을 적어주세요.</div>'
			};
			
			if(chkVal.activate === 0){
				if(res[1] !== ''){
					res[1] += '<br>'+errTxt.act;
				}else{
					res[1] += errTxt.act;
				}
			}
			
			if(chkVal.host === 0){
				if(res[1] !== ''){
					res[1] += '<br>'+errTxt.host;
				}else{
					res[1] += errTxt.host;
				}
			}else if(chkVal.host > 1){
				if(res[1] !== ''){
					res[1] += '<br>'+errTxt.hostDuplicate;
				}else{
					res[1] += errTxt.hostDuplicate;
				}
			}
			
			if(chkVal.hostID === ""){
				if(res[1] !== ''){
					res[1] += '<br>'+errTxt.hostID;
				}else{
					res[1] += errTxt.hostID;
				}
			}
			
			if(res[1] !== ""){
				res[0] = false;
			}else{
				res[0] = true;
				res[2] = [
					$('input[name="activeRange"]:checked').val(),
					$('input[name="shopHost"]:checked').val(),
					$('#shopHostID').val()
				];
			}
			if(callBack !== undefined) callBack(res);
		},
        setDomEvent : function(){
            //let bkg = smiToolFn.vars.bkg;
            let setConnecting = smiToolFn.fns.setConnecting;
            let nowUrl = smiToolFn.vars.nowUrl;
            let defObj = smiToolFn.vars.defObj;
            let loaderFn = smiToolFn.fns.loaderFn;
            let alertFn = smiToolFn.fns.alertFn;
            let checkFn = smiToolFn.fns.checkFn;
			let login = smiToolFn.fns.login;
            let logout = smiToolFn.fns.logout;
            

            $('#alertWrap button').click(function(){
                $('#alertWrap').removeClass('active');
            });

            let rangeVal = defObj.type;
            // 오픈시 라디오 체크 이벤트
            $('#option input[name="activeRange"]').each(function(key, value){
                if(value.value == rangeVal){
                    $(value).trigger('click').parent().addClass('on');
                }
            });

            $('#option input[name="activeRange"]').change(function(){
                $('label').removeClass('on');
                $(this).parent().addClass('on');
                $('#submit').addClass('on');
            });

            //todo wabi 적용버튼 이벤트 ==========================
            $('#submit').on({
                'click': function(){
					checkFn(function(chkRes){
						if(chkRes[0]){
							defObj.type = chkRes[2][0];
							defObj.host = chkRes[2][1];
							defObj.hostID = chkRes[2][2];
							
							setConnecting('reload','smiTool',JSON.stringify(defObj));
						}else{
							alertFn(chkRes[1]);
						}
					});
                }
            });

			//make chkbox inputs be as like radio btn
			$('#hostChk input[name="shopHost"]').each(function(){
				let $this = $(this);
				$this.click(function(e){
					let val = $this.val();
					let sibling;
					if(val === 'cf24'){
						sibling = $this.closest('#hostChk').find('input[value="mk"]');
					}else if(val === 'mk'){
						sibling = $this.closest('#hostChk').find('input[value="cf24"]');
					}
					
					if(sibling.is(':checked')){
						sibling.prop( "checked" ,false );
					}
				});
			});
			
            $('#hostChk input[value="'+defObj.host+'"]').prop( "checked" ,true );
			$('input#shopHostID').val(defObj.hostID);
        }
    },
    run : function(){
        let _this = this;
        let vars = _this.vars;
        //let bkg = vars.bkg;
		
		//type, key, value
		chrome.tabs.executeScript(null, {
			code:"localStorage.getItem('smiTool');"
		},function(res){
			vars.smiT = res[0];
			//bkg.console.log(res[0]);
			//bkg.console.log(smiToolFn.vars.nowUrl);
			if(vars.smiT !== null && vars.smiT !== undefined && vars.smiT !== ''){
				vars.defObj = JSON.parse(vars.smiT);
				//bkg.console.log('exist',vars);
			}else{
				//bkg.console.log('null',vars);
			}
			$('#loader').removeClass('loading');
			_this.fns.setDomEvent();
		});
    }
};



//get Current Tab URL and start to set elementDom event function
chrome.tabs.query({active:true,currentWindow:true},function(tabArray){
    var url = new URL(tabArray[0].url);
    url = url.host;
    smiToolFn.vars.nowUrl = url;

    // runing endpoint
    $('document').ready(function(){
        smiToolFn.run();
    });
});


